module requests.ussd;

import vibe.vibe;
import response;
import structures;
import sql;
import singlog;

// Получить список всех групп USSD
void getListUSSDGroups(HTTPServerRequest req, HTTPServerResponse res) {
    auto numbers = sqlGetUSSDNumbers();
    render!("list_ussd_groups.dt", numbers)(res);
}

// Получить список USSD конкретной группы
void getListGroupUSSD(HTTPServerRequest req, HTTPServerResponse res) {
    auto jsr = req.json;
    res.writeJsonBody(sqlGetListUSSD(jsr["to"].get!string).serializeToJson());
}

// Просмотр USSD
void getViewUSSD(HTTPServerRequest req, HTTPServerResponse res) {
    auto jsr = req.json;
    auto dataUSSD = sqlGetUSSD(jsr["id"].to!int);
    render!("ussd.dt", dataUSSD)(res);
}

// Удалить USSD
void sendDelUSSD(HTTPServerRequest req, HTTPServerResponse res) {
    auto jsr = req.json;
    int idussd = jsr["id"].get!int;
    
    if (!sqlDeleteUSSD(idussd)) {
        res.send(true, "Не удалось удалить USSD");
        return;
    }

    res.send();
}
